--[[
	You can copy, use this in your mods, an change it, as long as you give me credit as the original coder. [Jordan4Ibanez]
]]--
stairs.register_stair_and_slab("grass", "default:dirt_with_grass",
		{crumbly=3},
		{"default_grass.png"},
		"Grass Slab",
		default.node_sound_stone_defaults())
num_nodes = {}
thickness = {}
function minetest.generate_nodes(node_id,base_block,node_table,node_thickness)
	last_time = 0
	thickness[node_id] = node_thickness
	num_nodes[node_id] = 0
	for k,v in pairs(node_table) do
		num_nodes[node_id] = num_nodes[node_id] + 1
	end
	minetest.register_on_generated(function(minp, maxp, blockseed)
		local testing_node = minetest.env:find_node_near({x=(minp.x + maxp.x)/2,y=(minp.y + maxp.y)/2,z=(minp.z + maxp.z)/2}, 40, base_block)
		if testing_node == nil then
			return
		end
		--let's find the lowest point of air
		baser = nil
		for y = minp.y, maxp.y do
			for x = minp.x, maxp.x do
				for z = minp.z, maxp.z do
					local get_node = minetest.env.get_node
					local test = get_node(minetest.env, {x=x,y=y,z=z}).name
					if test == "air" then
						baser = y - 1
						break
					end
				end
				if baser ~= nil then
					break
				end
				z=0
			end
			if baser ~= nil then
				break
			end
			x=0
		end
		for x = minp.x,maxp.x do
			for z = minp.z,maxp.z do
				for y = baser,maxp.y do
					local get_node = minetest.env.get_node
					local test = get_node(minetest.env, {x=x,y=y,z=z}).name
					--local test = minetest.env:get_node({x=x,y=y,z=z}).name
					if test == base_block then
						if minetest.env:get_node({x=x,y=y+1,z=z}).name == "air" then
							if minetest.env:get_node({x=x,y=y+1,z=z+1}).name ~= "air" or minetest.env:get_node({x=x,y=y+1,z=z-1}).name == "default:dirt_with_grass" or minetest.env:get_node({x=x+1,y=y+1,z=z}).name == "default:dirt_with_grass" or minetest.env:get_node({x=x-1,y=y+1,z=z}).name == "default:dirt_with_grass" then
								local noding = node_table[math.random(1,num_nodes[node_id])]
								if noding ~= nil then
									local set_node = minetest.env.set_node
									local setter = set_node(minetest.env, {x=x,y=y+1,z=z}, {name=noding})
								end
							end
						end
						y = minp.y
						z = z + 1
					elseif test == "default:water_source" or test == "default:sand" or test == "default:clay" or test == "air" then
						y = minp.y
						z = z + 1			
					end
				end
			end
			z=0
		end
	end)
end
minetest.generate_nodes("normal","default:dirt_with_grass",{"stairs:slab_grass"},0.2)